#---------------------------------------------------------------------
# Exercise 1
#---------------------------------------------------------------------
#----------------------- question 1 ----------------------------------
# Wiener process with drift
#----------------------- question 1a ---------------------------------
Delta=0.0001
n=1000
I=-10
V0=-65
time=1:n*Delta
EV=V0+I*time
CovT=matrix(time, ncol=n, nrow=n)
for (i in 2:n){
  CovT[i,1:(i-1)]=1:(i-1)*Delta
}
sigma=1
CovV=sigma^2*CovT
#----------------------- question 1b ---------------------------------
library(mvtnorm)
V = rmvnorm(1,mean=EV, sigma=CovV)
plot(time, V, type='l')
#----------------------- question 1c ---------------------------------
sigma=10
CovV=sigma^2*CovT
library(mvtnorm)
V = rmvnorm(1,mean=EV, sigma=CovV)
plot(time, V, type='l')
sigma=20
CovV=sigma^2*CovT
library(mvtnorm)
V = rmvnorm(1,mean=EV, sigma=CovV)
plot(time, V, type='l')

#----------------------- question 2 ---------------------------------
# Ornstein-Uhlenbeck
#----------------------- question 2b ---------------------------------
Delta=0.001
n=1000
I=50
V0=-65
tau = 0.5
alpha = V0+tau*I
sigma=10
time=1:n*Delta
V = rep(0,n)
V[1]=V0
expdtau = exp(-Delta/tau)
sdcond=sqrt(sigma^2*tau/2*(1-expdtau^2))
for (i in 1:(n-1)){
  V[i+1] = V[i]*expdtau + alpha*(1-expdtau) + rnorm(1,0, sdcond)
}
plot(time,V,type='l')
#----------------------- question 2c ---------------------------------
Delta=0.001
n=5000
I=50
V0=-65
tau = 0.5
alpha = V0+tau*I
sigma=10
expdtau = exp(-Delta/tau)
sdcond=sqrt(sigma^2*tau/2*(1-expdtau^2))
S=-45
nspikes=20
Tspikes=rep(0,nspikes)
Vspikes=c()
for (j in 1:nspikes){
  i=1
  V = rep(0,n)
  V[1]=V0
  while (i<n & V[i]<S){
    V[i+1] = V[i]*expdtau + alpha*(1-expdtau) + rnorm(1,0, sdcond)
    i = i+1
  }
  Tspikes[j] = i*Delta
  Vspikes=c(Vspikes,V[1:i+1])
}
#----------------------- question 2d ---------------------------------
hist(Tspikes)
plot(1:length(Vspikes)*Delta,Vspikes,type='l')
#----------------------- question 2e ---------------------------------
Delta=0.001
n=5000
I=20
alpha = V0+tau*I
S=-45
nspikes=20
Tspikes=rep(0,nspikes)
Vspikes=c()
for (j in 1:nspikes){
  i=1
  V = rep(0,n)
  V[1]=V0
  while (i<n & V[i]<S){
    V[i+1] = V[i]*expdtau + alpha*(1-expdtau) + rnorm(1,0, sdcond)
    i = i+1
  }
  Tspikes[j] = i*Delta
  Vspikes=c(Vspikes,V[1:i+1])
}
hist(Tspikes)
plot(1:length(Vspikes)*Delta,Vspikes,type='l')


#--------------------------------------------------------------------
# Exercise 2
#--------------------------------------------------------------------
#----------------------- question 1 ---------------------------------
# Ornstein-Uhlenbeck
Delta=0.001
n=5000
I=50
V0=-65
tau = 0.5
alpha = V0+tau*I
sigma=10
S=-45
nspikes=20
Tspikes=rep(0,nspikes)
Vspikes=c()
for (j in 1:nspikes){
  i=1
  V = rep(0,n)
  V[1]=V0
  while (i<n & V[i]<S){
    V[i+1] = V[i] - Delta*(V[i]-alpha)/tau   + rnorm(1,0, sqrt(Delta)*sigma)
    i = i+1
  }
  Tspikes[j] = i*Delta
  Vspikes=c(Vspikes,V[1:i+1])
}
hist(Tspikes)
plot(1:length(Vspikes)*Delta,Vspikes,type='l')
#----------------------- question 2a ---------------------------------
# Feller process
Delta=0.001
n=5000
I=50
V0=-65
VI=-70
tau = 0.5
alpha = V0+tau*I
sigma=10
S=-45
nspikes=20
Tspikes=rep(0,nspikes)
Vspikes=c()
for (j in 1:nspikes){
  i=1
  V = rep(0,n)
  V[1]=V0
  while (i<n & V[i]<S){
    V[i+1] = V[i] - Delta*(V[i]-alpha)/tau   +  sqrt(Delta)*sigma*sqrt(V[i]-VI)*rnorm(1)
    i = i+1
  }
  Tspikes[j] = i*Delta
  Vspikes=c(Vspikes,V[1:i+1])
}
hist(Tspikes)
plot(1:length(Vspikes)*Delta,Vspikes,type='l')

#----------------------- question 2b ---------------------------------
Delta=0.001
n=5000
I=50
V0=-65
VI=-80
tau = 0.5
alpha = V0+tau*I
sigma=10
S=-45
nspikes=20
Tspikes=rep(0,nspikes)
Vspikes=c()
for (j in 1:nspikes){
  i=1
  V = rep(0,n)
  V[1]=V0
  while (i<n & V[i]<S){
    V[i+1] = V[i] - Delta*(V[i]-alpha)/tau   +  sqrt(Delta)*sigma*sqrt(V[i]-VI)*rnorm(1)
    i = i+1
  }
  Tspikes[j] = i*Delta
  Vspikes=c(Vspikes,V[1:i+1])
}
hist(Tspikes)
plot(1:length(Vspikes)*Delta,Vspikes,type='l')

#--------------------------------------------------------------------
# Exercise 3
#--------------------------------------------------------------------
#----------------------- question 1 ---------------------------------
alpha.beta = function(X, theta){
  # calculate \alpha and \beta functions of Morris Lecar system
  # INPUT
  # X = (V, W) : current value of states
  # theta = (gL, gCa, gK, V1, V2, V3, V4,  sigma, gamma,VK, VL, phi, C, VCa, I)   
  V3 = theta[6]; V4 = theta[7]; phi = theta[12];
  alpha = 1/2 * phi * cosh((X[1]-V3)/(2*V4)) * (1 + tanh((X[1]-V3)/V4));
  beta = 1/2 * phi * cosh((X[1]-V3)/(2*V4)) * (1 - tanh((X[1]-V3)/V4));
  return( c(alpha, beta ))
}

minfty = function(X, theta){
  # calculate m_\infty function of Morris Lecar system
  # INPUT
  # X = (V, W) : current value of states
  # theta = (gL, gCa, gK, V1, V2, V3, V4,  sigma, gamma,VK, VL, phi, C, VCa, I) 
  V1 = theta[4]; V2 = theta[5];
  minfty.V = 1/2*(1 + tanh( (X[1]-V1)/V2 ));
  return( minfty.V )
}

Wdrift = function(X, theta){
  # calculate drift function of second equation (Wt) of Morris Lecar system
  # INPUT
  # X = (V, W) : current value of states
  # theta = (gL, gCa, gK, V1, V2, V3, V4,  sigma, gamma,VK, VL, phi, C, VCa, I)   
  ab = alpha.beta(X, theta); alpha = ab[1]; beta = ab[2];
  drift = alpha * (1-X[2]) - beta * X[2];
  return( drift )
}

Vdrift = function(X, theta){
  # calculate drift function of first equation (Vt) of Morris Lecar system
  # INPUT
  # X = (V, W) : current value of states
  # theta = (gL, gCa, gK, V1, V2, V3, V4,  sigma, gamma,VK, VL, phi, C, VCa, I)   
  VK = theta[10]; VL = theta[11]; C = theta[13]; VCa = theta[14]; I = theta[15]; 
  gL = theta[1]; gCa = theta[2]; gK = theta[3]; 
  V = X[1]; W = X[2]
  drift = 1/C * (-gCa * minfty(X,theta) * (V - VCa) - gK * W * (V - VK) - gL * (V - VL) + I); 
  return( drift )
}

Wvolatility = function(X, theta, model.W = 'model2'){
  # calculate volatility function of second equation (Wt) of Morris Lecar system
  # INPUT
  # X = (V, W) : current value of states
  # theta =  (gL, gCa, gK, V1, V2, V3, V4,  sigma, gamma,VK, VL, phi, C, VCa, I) 
  # model.W : name of the model : 'model1' if sqrt(2 * alpha * beta * (1 - W) * W)
  # 'model2' if sqrt(2 * alpha * beta / (alpha+beta) * (1 - W) * W)
  # 'model3' if sqrt(2 * alpha * beta * (1 - W) * W)  
  W = X[2]; sigma = theta[8];
  ab = alpha.beta(X, theta); alpha = ab[1]; beta = ab[2];
  if (model.W=='model1'){volatility = sigma * sqrt(2 * alpha * beta * (1 - W) * W);}
  if (model.W=='model2'){volatility = sigma * sqrt(2 * alpha * beta / (alpha+beta) * (1 - W) * W);}
  if (model.W=='model3'){volatility = sigma * sqrt(alpha * (1 - W) + beta * W);}
  return( volatility)
}

Vvolatility = function(X, theta){
  # calculate volatility function of first equation (Vt) of Morris Lecar system
  # INPUT
  # X = (V, W) : current value of states
  # theta =  (gL, gCa, gK, V1, V2, V3, V4,  sigma, gamma,VK, VL, phi, C, VCa, I)  
  gamma = theta[9]; volatility = gamma;
  return( volatility)
}

VWvolatility = function(X, theta){
  # calculate volatility function of system (Vt, Wt) of Morris Lecar system
  # INPUT
  # X = (V, W) : current value of states
  # theta = (gL, gCa, gK, V1, V2, V3, V4,  sigma, gamma,VK, VL, phi, C, VCa, I)   
  rho = 0;
  V.volatility = Vvolatility(X, theta); W.volatility =Wvolatility(X, theta);
  Sigma = matrix(c(V.volatility, rho, rho, W.volatility), 2,2);
  return(Sigma)
}

MorrisLecar = function(X, theta){
  # calculate drift of Morris Lecar system
  # INPUT
  # X = (V, W) : current value of states
  # theta = (gL, gCa, gK, V1, V2, V3, V4,  sigma, gamma,VK, VL, phi, C, VCa, I)  
  V.drift = Vdrift(X, theta);  W.drift = Wdrift(X, theta); drift  = c(V.drift, W.drift);
  volatility = VWvolatility(X, theta); 
  return(list(drift = drift, volatility = volatility))
}

EulerMLonestep = function(X, delta, theta){
  # simulate one step of Euler approximation of Morris Lecar system
  # INPUT
  # X = (V, W) : current value of states
  # delta : step size of Euler scheme
  # theta = (gL, gCa, gK, V1, V2, V3, V4,  sigma, gamma,VK, VL, phi, C, VCa, I) 
  
  ML = MorrisLecar(X, theta); drift = ML$drift; volatility = ML$volatility;
  Xnew = X + delta * drift  + t(sqrt(delta) * volatility %*% rnorm(2))
  return(Xnew)
}

EulerML = function(X0, delta, n, theta, op.plot = FALSE){
  # simulate Euler approximation of Morris Lecar system
  # INPUT
  # X0 = (V0, W0) : initial value of states
  # delta : step size of Euler scheme
  # n : length of the simulation
  # theta = (gL, gCa, gK, V1, V2, V3, V4,  sigma, gamma,VK, VL, phi, C, VCa, I) 
  
  deltasimu = delta/10; nsimu = n*10;
  X = matrix(0,nsimu,2); X[1,] = X0 
  for (i in 1:(nsimu-1)){
    X[i+1, ] = EulerMLonestep(X[i,], deltasimu, theta)
  }
  if (op.plot){
    par(mfrow=c(1,3))
    plot(X[,1], type = 'l', xlab ='time', ylab = expression(V[t])); plot(X[,2],  type = 'l', xlab ='time', ylab = expression(W[t])); plot(X[,1], X[,2], type = 'l', xlab = expression(V[t]), ylab = expression(W[t]))
  }
  X = X[seq(from = 1, by = 10, length.out = n),]
  return(X)
}


#----------------------- question 2 ----------------------------------
# parameter values
VK = -84; VL = -60; VCa = 120; C = 1;  I = 88/20; 
gL = 2/20; gCa = 4.4/20; gK = 8/20; V1 = -1.2; V2 = 18; V3 = 2; V4 = 30;
phi = 0.04; sigma = 0.03; gamma = 1; 
thetasimu = c(gL, gCa, gK, V1, V2, V3, V4, sigma, gamma, VK, VL, phi, C, VCa,  I )
V0 = -26; W0 = 0.2; X0 = c(V0, W0);
delta = 0.1; n = 5000;
time = (1:n)*delta
# simulation 
X = EulerML(X0, delta, n, thetasimu, op.plot = TRUE)
V = X[,1]
W = X[,2]
par(mfrow=c(1,2))
plot(time, V, type = "l")
plot(time, W, type = "l")
