#---------------------------------------------------------------------
# Exercise 1
#---------------------------------------------------------------------
#----------------------- question 1 ----------------------------------
# Wiener process with drift
#----------------------- question 1a ---------------------------------
Delta=0.0001
n=300
I=-10
V0=-65
time=1:n*Delta
EV=V0+I*time
CovT=matrix(time, ncol=n, nrow=n)
for (i in 2:n){
  CovT[i,1:(i-1)]=1:(i-1)*Delta
}
sigma=10
CovV=sigma^2*CovT
library(mvtnorm)
V = rmvnorm(1,mean=EV, sigma=CovV)
plot(time, V, type='l')
#----------------------- question 1b ---------------------------------
Ihat = mean(diff(c(V)))/Delta
shat = sqrt(mean((diff(c(V))-Ihat*Delta)^2)/Delta)
#----------------------- question 1c ---------------------------------
nsimu=100
Ihatrep=rep(0,nsimu)
shatrep=rep(0,nsimu)
for (j in 1:nsimu){
  V = rmvnorm(1,mean=EV, sigma=CovV)
  Ihatrep[j] = mean(diff(c(V)))/Delta
  shatrep[j] = sqrt(mean((diff(c(V))-Ihat*Delta)^2)/Delta)  
}
mean(Ihatrep)
sqrt(mean((Ihatrep-I)^2))
mean(shatrep)
sqrt(mean((shatrep^2-sigma^2)^2))
par(mfrow=c(1,2))
hist(Ihatrep); abline(v=I)
hist(shatrep); abline(v=sigma)
#----------------------- question 1d ---------------------------------
FIM = matrix(c(1/(sigma^2), 0, 0, 1/(2*sigma^4)),2,2)
sqrt(solve(FIM))
sqrt(n*Delta)*sd(Ihatrep)
sqrt(n)*sd(shatrep^2)

#----------------------- question 2 ----------------------------------
# Ornstein Uhlenbeck
#----------------------- question 2a ----------------------------------
Delta=0.001
n=1000
I=50
V0=-65
tau = 0.5
alpha = V0+tau*I
sigma=10
time=1:n*Delta
V = rep(0,n)
V[1]=V0
expdtau = exp(-Delta/tau)
sdcond=sqrt(sigma^2*tau/2*(1-expdtau^2))
for (i in 1:(n-1)){
  V[i+1] = V[i]*expdtau + alpha*(1-expdtau) + rnorm(1,0, sdcond)
}
plot(time,V,type='l')
#----------------------- question 2b ----------------------------------
X = matrix(c(rep(1,n-1), V[1:(n-1)]), ncol=2, byrow=FALSE)
thetahat = solve(t(X)%*%X)%*%t(X)%*%V[2:n] # theta=(alpha(1-rho), rho)
rhohat = thetahat[2]
tauhat = -Delta/log(rhohat)
betahat = thetahat[1]
alphahat=betahat/(1-rhohat)
sigma2hat = 2/((1-rhohat^2)*tauhat)*mean((V[2:n]-alphahat-(V[1:(n-1)]-alphahat)*rhohat)^2)
sigmahat=sqrt(sigma2hat)
#----------------------- question 2c ----------------------------------
X = Delta*matrix(c(rep(1,n-1), -V[1:(n-1)]), ncol=2, byrow=FALSE)
thetahat = solve(t(X)%*%X)%*%t(X)%*%c(diff(V)) # theta=(alpha(1-rho), rho)
tauhat=1/thetahat[2]
alphahat=thetahat[1]*tauhat
sigmahat = sqrt(mean((diff(V)+Delta*V[1:(n-1)]/tauhat-Delta*alphahat/tauhat)^2))/sqrt(Delta)

#----------------------- question 3 ----------------------------------
#----------------------- question 3a ----------------------------------
Delta=0.001
n=1000
I=50
V0=-65
VI=-90
tau = 0.5
alpha = V0+tau*I
sigma=5
V = rep(0,n)
V[1]=V0
for (i in 1:n){
  V[i+1] = V[i] - Delta*(V[i]-alpha)/tau   +  sqrt(Delta)*sigma*sqrt(V[i]-VI)*rnorm(1)
}
#----------------------- question 3b ----------------------------------
rho1n=exp(-0:n*Delta/tau)
alphahat = sum((V-V0*rho1n)*(1-rho1n))/sum((1-rho1n)^2)
rho=exp(-Delta/tau)
alphahatC=mean(V[2:n]-V[1:(n-1)]*rho)/(1-rho)
#----------------------- question 3c ----------------------------------
nsimu=100
alphahatrep=rep(0,nsimu)
alphahatCrep=rep(0,nsimu)
for (j in 1:nsimu){
  V[1]=V0
  for (i in 1:n){
    V[i+1] = V[i] - Delta*(V[i]-alpha)/tau   +  sqrt(Delta)*sigma*sqrt(V[i]-VI)*rnorm(1)
  }
  alphahatrep[j] = sum((V-V0*rho1n)*(1-rho1n))/sum((1-rho1n)^2)
  alphahatCrep[j]=mean(V[2:n]-V[1:(n-1)]*rho)/(1-rho)  
}
hist(alphahatrep)
hist(alphahatCrep)
 